#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""list.py uses list.kid to create a webpage with a list of all or selected projects."""

import kid
import logic

def index(req,search1=None,search_fields1=None,techniques1=[],sort_order1="asc",sort_by1="start_date"):
   req.content_type = "text/html"

   #Topic of the page
   topic = "List of Projects"

   #Projectlist (according to search)
   if search1=="":
      search1=None
   if search_fields1 != None:
      search_fields2=[]
      search_fields2.append(search_fields1)
   else:
      search_fields2=None
   project_list = logic.list_projects(search=search1,search_fields=search_fields2,techniques=techniques1,sort_order=sort_order1,sort_by=sort_by1)
   if (project_list[1]==0):
      projects = project_list[0]
   elif(project_list[1]==1):
      projects = [{'project_no':'','project_name':'No projects found','start_date':'','end_date':'','short_description':'','small_image':''}]
   elif(project_list[1]==2):
      projects = [{'project_no':'','project_name':'Could not read data-file','start_date':'','end_date':'','short_description':'','small_image':''}]

   #Send to kid-template
   template = kid.Template(name='templates/list', title='List of projects', topic=topic, projects=projects)   
   template.cache = False
   return template.serialize(output='xhtml-strict')
