#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""logic.py trys to fetch lists and dictionarys from data.py
It returns tuples with eventual fetched information and an error-code.
logic.py also writes all calls to the logg (logg.txt)

Possible error-codes:
   0 - Everything works
   1 - Project id doesn't exist
   2 - data.csv couldn't be read"""

import data, os
from time import gmtime, strftime

def get_project(project_id):
    """get_project(...) trys to fetch a dictionary with all information about one specified project from data.lookup_project(...).

    Example:
       get_project(4) returns:
       ({'project_no':4,'project_name':'Apache',...},0)"""
    file = open(os.path.dirname(__file__) + os.sep + 'logg.txt', 'a')
    curtime = strftime("%a, %d %b %Y %H:%M:%S", gmtime())
    file.write(curtime)
    try:        
        project_data = data.lookup_project(project_id)
    except:
        project_status = 2
        project_data = None
        return (project_data,project_status)
    if (project_data == None):
        project_status = 1
        return (project_data,project_status)
    project_status = 0
    return (project_data,project_status)


def list_projects(sort_by='start_date', sort_order='asc', techniques=[], search=None, search_fields=None):
    """list_projects(...) calls data.retrieve_projects(...) with the received searh-parameters and gets a list with one dictionary for every matching project.

    Example:
       list_projects(sort_by='start_date',search='object-oriented',search-fields='project_name') returns:
       ([{'project_no':1,'project_name':'Object-oriented programming',...}],0)"""
    file = open(os.path.dirname(__file__) + os.sep + 'logg.txt', 'a')
    curtime = strftime("%a, %d %b %Y %H:%M:%S ", gmtime())
    file.write(curtime+"list_projects(sort_by='"+sort_by+"', sort_order='"+sort_order+"', techniques='"+str(techniques)+"', search='"+str(search)+"', search_fields='"+str(search_fields)+"'")
    try:        
        projects_list = data.retrieve_projects(sort_by,sort_order,techniques,search,search_fields)
    except:
        project_status = 2
        projects_list = None
        file.write("returned statuscode 2"+"\n")
        return (projects_list,project_status)
    if (projects_list == []):
        project_status = 1
        projects_list = None
        file.write("returned statuscode 1"+"\n")
        return (projects_list,project_status)
    project_status = 0
    file.write("returned statuscode 0"+"\n")
    return (projects_list,project_status)


def techniques():
    """techniques() calls data.retrieve_technique_stats and fetches statistics for technques used in the projects.

    Example:
       techniques() returns:
       ([{'name':'Apache','count':3,'projects':[{'project_no':1,'project_name':'Project1'}],0)"""
    file = open(os.path.dirname(__file__) + os.sep + 'logg.txt', 'a')
    curtime = strftime("%a, %d %b %Y %H:%M:%S ", gmtime())
    file.write(curtime+ "techniques() ")
    try:
        techniques_stats = data.retrieve_technique_stats()
    except:
        techniques_status = 2
        techniques_stats = None
        file.write("returned statuscode 2"+"\n")
        return (techniques_stats,techniques_status)
    if not techniques_stats:
        techniques_status = 1
        techniques_stats = None
        file.write("returned statuscode 1"+"\n")
        return (techniques_stats,techniques_status)
    techniques_status = 0
    file.write("returned statuscode 0"+"\n")
    return (techniques_stats,techniques_status)
    
