#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""project.py uses project.kid to create a webpage for a selected project."""

import kid, logic

def index(req, id):
   req.content_type = "text/html"
   project_tuple = logic.get_project(id)
   if(project_tuple[1]==0):
      project=project_tuple[0]
   elif(project_tuple[1]==1):
      project = {'project_no':'','project_name':'No project found','start_date':'','end_date':'','course_id':'','course_name':'','academic_credits':'','techniques_used':'','short_description':'','long_description':'','small_image':'','big_image':'','group_size':'','external_link':''}
   else:
      project = {'project_no':'','project_name':'Could not read from data-file','start_date':'','end_date':'','course_id':'','course_name':'','academic_credits':'','techniques_used':'','short_description':'','long_description':'','small_image':'','big_image':'','group_size':'','external_link':''}
   template = kid.Template(name='templates/project', title='Information about project', project=project)   
   template.cache = False
   return template.serialize(output='xhtml-strict')


